/**
 * Copyright 2016 vip.com.
 * <p>
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 *  the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 * </p>
 **/

package com.vip.saturn.job.console.utils;

import java.util.Arrays;
import java.util.List;
import java.util.TimeZone;

/**
 * @author hebelala
 */
public class SaturnConstants {

	public static final int HEALTH_CHECK_VERSION_MAX_SIZE = 10000;

	public static final String DEAL_SUCCESS = "ok";

	public static int JOB_CAN_BE_DELETE_TIME_LIMIT = 2 * 60 * 1000;// 作业可以被删除的时间限制(单位：ms)

	/**
	 * 容器伸缩计划作业名前缀
	 */
	public static final String SYSTEM_SCALE_JOB_PREFEX = "system_scale_";

	/**
	 * 获取sys_config表数据的间隔时间
	 */
	public static final long GET_SYS_CONFIG_DATA_REFRESH_TIME = 1000L * 60 * 5;

	public static final String TIME_ZONE_ID_DEFAULT = "Asia/Shanghai";

	public static final List<String> TIME_ZONE_IDS = Arrays.asList(TimeZone.getAvailableIDs());

	public static final String FILE_SEPARATOR = System.getProperty("file.separator");

	public static final String CACHES_FILE_PATH = System.getProperty("user.home") + FILE_SEPARATOR + ".saturn"
			+ FILE_SEPARATOR + "saturn_console" + FILE_SEPARATOR + "caches";

	public static final String NO_GROUPS_LABEL = "未分组";

	public static final int JOB_IS_ENABLE = 1;

	public static final int JOB_IS_DISABLE = 0;

	public static final String SYSTEM_CONFIG_ENV = "ENV";

}
