/**
 * Copyright 1999-2015 dangdang.com.
 * <p>
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * </p>
 */

package com.vip.saturn.job.internal.listener;

import org.apache.curator.framework.CuratorFramework;
import org.apache.curator.framework.recipes.cache.TreeCacheEvent;
import org.apache.curator.framework.recipes.cache.TreeCacheListener;

/**
 * 作业注册中心的监听器.
 * 
 * 
 */
public abstract class AbstractJobListener implements TreeCacheListener {

	@Override
	public final void childEvent(final CuratorFramework client, final TreeCacheEvent event) throws Exception {
		String path = null == event.getData() ? "" : event.getData().getPath();
		if (path.isEmpty()) {
			return;
		}
		dataChanged(client, event, path);
	}

	protected abstract void dataChanged(final CuratorFramework client, final TreeCacheEvent event, final String path);
}
